/********************************************************************************

 Programmed by SEUNG-JO BAE 

  - Goal: 

  - Algorithm: 

  - Input: 

  - Output: 

  - Version: 1.2
            
  - Assumption: 

  - Note: 1) setup_bucket_parameter()

********************************************************************************/

#include "global.h"

/******************************************************************************
 *                                                                            *
 *  Function : read_input()                                                   *
 *                                                                            *
 ******************************************************************************/
                 
                          /*--- Input Format ---*

                              s_rank = t_rank
                 
                              s_N[0]
                              s_nproc[0]
                              s_width[0]

                                 .
                                 .
                                 .

                              s_N[s_rank-1]
                              s_nproc[s_rank-1]
                              s_width[s_rank-1]



                              t_N[0]
                              t_nproc[0]
                              t_width[0]

                                 .
                                 .
                                 .

                              t_N[t_rank-1]
                              t_nproc[t_rank-1]
                              t_width[t_rank-1]

                           *-------------------*/

void one_dim_read_input(pr_control)
     int pr_control;
{
   Boolean error;
   int i, j, k;
   int s_total = 1, t_total=1;
   int save, d, p;

   void L_table();

   /*---------------- Rank of the Source Array ----------------------------*/
   if (pr_control==0 && only_master)
       printf("\nEnter rank of the source array (Max=%d): ", Rankmax);
   if (only_master) 
     scanf("%d", &s_rank);
   MPI_Bcast(&s_rank, 1, MPI_INT, master, ORI_WORLD);
   if ( s_rank < 1 || s_rank > Rankmax ) {
     printf("\n??? Improper s_rank. Exit!\n");
     exit(0);
   }


   /*-------------------- from dim=0 to dim=s_rank-1 ----------------------*/
   for (i=0; i<s_rank; ++i) {

     if (pr_control==0 && only_master)
       printf("\n***** Dimension = %d *****\n", i);

       /*------------ Source Distribution ------------------*/

     if (pr_control==0 && only_master)
         printf("\n   ===>> SOURCE <<===\n");
     if (pr_control==0 && only_master)
       printf("\n   Enter source domain size (Max=%d): ", Nmax);
     if (only_master) 
       scanf("%d", &s_N[i]);
     MPI_Bcast(&s_N[i], 1, MPI_INT, master, ORI_WORLD);

     if ( s_N[i] < 1 || s_N[i] > Nmax ) {
       printf("\n??? Improper domain size. Exit!\n");
       exit(0);
     }

     save = s_total;
     if (pr_control==0 && only_master)
       printf("\n   Enter number of source processors (Max=%d): ", 
	      Floor(Procmax, s_total));
     if (only_master) 
       scanf("%d", &s_nproc[i]);
     MPI_Bcast(&s_nproc[i], 1, MPI_INT, master, ORI_WORLD);
     s_total *= s_nproc[i];
     if ( s_nproc[i] < 1 || 
	 s_total > ori_nproc || s_nproc[i] > s_N[i] ) {
       printf("\n??? Improper source processor number. Exit!\n");
       exit(0);
     }

     if ( s_nproc[i] == 1 ) {
       s_width[i] = s_N[i];
       s_L[i]     = s_N[i];
       if ( s_L[i] > Lmax ) {
	 printf("Error: Increas 'Lmax' !\n");
	 exit(0);
       }
     }
     else {
       if (pr_control==0 && only_master)
         printf("\n   Enter source width of a partition (Max=%d): ", 
	      s_N[i] / s_nproc[i]);
       if (only_master) 
	 scanf("%d", &s_width[i]);
       MPI_Bcast(&s_width[i], 1, MPI_INT, master, ORI_WORLD);

       if ( s_width[i] < 1 || s_width[i] > s_N[i] || s_width[i] > Lmax ) {
	 printf("\n??? Improper source partition width. Exit!\n");
	 exit(0);
       }
     }

   }


   /*---------------- Rank of the Target Array ----------------------------*/

   t_rank = s_rank;

   /*-------------------- from dim=0 to dim=t_rank-1 ----------------------*/
   for (i=0; i<t_rank; ++i) {

     if (pr_control==0 && only_master)
       printf("\n***** Dimension = %d *****\n", i);

       /*------------ Target Distribution ------------------*/

     if (pr_control==0 && only_master)
       printf("\n\n   ===>> TARGET <<===\n");
     if (pr_control==0 && only_master)
       printf("\n   Enter target domain size (Max=%d): ", Nmax);
     if (only_master) 
       scanf("%d", &t_N[i]);
     MPI_Bcast(&t_N[i], 1, MPI_INT, master, ORI_WORLD);

     if ( t_N[i] < 1 || t_N[i] > Nmax ) {
       printf("\n??? Improper domain size. Exit!\n");
       exit(0);
     }

     save = t_total;
     if (pr_control==0 && only_master)
       printf("\n   Enter number of target processors (Max=%d): ", 
	      Floor(Procmax, t_total));
     if (only_master) 
       scanf("%d", &t_nproc[i]);
     MPI_Bcast(&t_nproc[i], 1, MPI_INT, master, ORI_WORLD);
     t_total *= t_nproc[i];
     if ( t_nproc[i] < 1 || 
	 t_total > ori_nproc || t_nproc[i] > t_N[i] ) {
       printf("\n??? Improper target processor number. Exit!\n");
       exit(0);
     }

     if ( t_nproc[i] == 1 ) {
       t_width[i] = t_N[i];
       t_L[i]     = t_N[i];
       if ( t_L[i] > Lmax ) {
	 printf("Error: Increas 'Lmax' !\n");
	 exit(0);
       }
     }
     else {
       if (pr_control==0 && only_master)
         printf("\n   Enter target width of a partition (Max=%d): ",
		t_N[i] / t_nproc[i] );
       if (only_master) 
	 scanf("%d", &t_width[i]);
       MPI_Bcast(&t_width[i], 1, MPI_INT, master, ORI_WORLD);

       if ( t_width[i] < 1 || t_width[i] > t_N[i] || t_width[i] > Lmax ) {
	 printf("\n??? Improper target partition width. Exit!\n");
	 exit(0);
       }
     }
   }

   /*===== Total number of processors =====*/

   s_tot_nproc = s_total;
   t_tot_nproc = t_total;

   tot_nproc = Max( s_tot_nproc, t_tot_nproc );

   if ( tot_nproc > ori_nproc) {
     printf("ERROR: Improper number of processors = %d", tot_nproc);
     exit(0);
   }

   i=0;
   for (k=ori_nproc-1; k >tot_nproc-1; --k)
     exclude[i++] = k;

   MPI_Comm_group( ORI_WORLD, &ORI_WORLD_GROUP );
   MPI_Group_excl( ORI_WORLD_GROUP, ori_nproc - tot_nproc, 
		   exclude, &WORLD_GROUP );
   MPI_Comm_create( ORI_WORLD, WORLD_GROUP, &WORLD );
   MPI_Group_free( &ORI_WORLD_GROUP );
   MPI_Group_free( &WORLD_GROUP );

   /*===== Who am I ? =====*/

   s_active = ori_my_pnum < s_tot_nproc;
   t_active = ori_my_pnum < t_tot_nproc;

   if ( s_active || t_active ) {
     MPI_Comm_size(WORLD, &k);
     if ( tot_nproc != k ) {
       printf("ERROR: Fail to generate communicator [WORLD]");
       exit(0);
     }
     MPI_Comm_rank(WORLD, &my_pnum);
   }

   if (s_active)
     map_to_grid(my_pnum, SOURCE, my_s_grid);
   if (t_active)
     map_to_grid(my_pnum, TARGET, my_t_grid);

  /*======= Local Size on each processors =======*/

   for (i=0; i<s_rank; ++i) 
     if ( s_nproc[i] > 1 ) {
       L_table(s_N[i], s_nproc[i], s_width[i], &s_twidth[i], 
	       s_L_table[i], &s_L_max[i], pr_control);
       s_L[i] = s_L_table[i][my_pnum];
       if ( s_L_max[i] > Lmax ) {
	 printf("\n??? Improper source L. Exit!\n");
	 exit(0);
       }
     }

   for (i=0; i<s_rank; ++i) 
     if ( t_nproc[i] > 1 ) {
       L_table(t_N[i], t_nproc[i], t_width[i], &t_twidth[i], 
	       t_L_table[i], &t_L_max[i], pr_control);
       t_L[i] = t_L_table[i][my_pnum];
       if ( t_L_max[i] > Lmax ) {
	 printf("\n??? Improper target L. Exit!\n");
	 exit(0);
       }
     }

  /*===== Total array size =====*/

  s_N_all = 1;
  s_L_all = 1;
  s_L_all_max = 1;

  t_N_all = 1;
  t_L_all = 1;
  t_L_all_max = 1;

  for (i=0; i<s_rank; ++i) {
    s_N_all *= s_N[i];
    s_L_all *= s_L[i];
    s_L_all_max *= s_L_max[i];
  }
  for (i=0; i<t_rank; ++i) {
    t_N_all *= t_N[i];
    t_L_all *= t_L[i];
    t_L_all_max *= t_L_max[i];
  }

  /*======= Dist info =======*/

  for (d=0; d<s_rank; ++d) 
    s_ntile[d]  = s_L_max[d]/s_width[d];

  for (d=0; d<t_rank; ++d) 
    t_ntile[d]  = t_L_max[d]/t_width[d];

  /*===== Map-to-Grid =====*/

  for (p=0; p<s_tot_nproc; ++p) 
    map_to_grid(p, SOURCE, s_grid[p]);
  for (p=0; p<t_tot_nproc; ++p) 
    map_to_grid(p, TARGET, t_grid[p]);

  /*======= Target is Block distribution? =======*/

   BLOCK = t_N[0] == t_width[0] * t_nproc[0];
 }


/******************************************************************************
 *                                                                            *
 *  Function : void L_table()
 *                                                                            *
 ******************************************************************************/

void L_table(N, nproc, width, twidth, L, L_max, pr_control)
     int N, nproc, width, *twidth;
     int L[Procmax], *L_max;
{
  int div, ddiivv, mod, mmoodd;
  int i;

  *twidth = nproc * width;
	     
  div         = N / *twidth;
  mod         = N % *twidth;
  ddiivv      = mod  / width;
  mmoodd      = mod  % width;
     
  /***********************************************************************
   *                                                                     *
   *   N   = div    * twidth + mod                                       *
   *   mod = ddiivv * width  + mmoodd                                    *
   *                                                                     *
   *         div*twidth                                   mod            *
   *  |=======================================|--------------|......|    *
   *         twidth = nproc*width               ddiivv*width  mmoodd     *
   *                                                                     *
   ***********************************************************************/

  if (pr_control == 0) {
    MPI_Barrier(WORLD);
    if (only_master) {
      printf("\n *** N = %d, nproc = %d, width = %d, twidth = %d\n", 
	     N,nproc,width,*twidth);
      printf("\n === div = %d, mod = %d, ddiivv = %d, mmoodd = %d\n",
	     div, mod, ddiivv, mmoodd);
    }
    MPI_Barrier(WORLD);
  }

  for (i=0; i<nproc; ++i) {
    
    L[i] = div * width;

    if ( i < ddiivv )
      L[i] += width;
    else if ( i == ddiivv )
      L[i] += mmoodd;
    /***
    if (pr_control == 0)
      printf("[PN:%2d] size = %d\n", i, L[i]);
      ***/
  }

  *L_max = L[0];

  if (pr_control == 0 && only_master)
    printf("*** L_max = %d\n", *L_max);
}

/******************************************************************************
 *                                                                            *
 *  Function : void setup_osc()
 *                                                                            *
 ******************************************************************************/

void setup_osc()
{
  int i, p, d;

  /*===== Clear comm. vectors =====*/

  for (p=0; p<tot_nproc; ++p) {
    sendl[p] = 0;
    recvl[p] = 0;
    send_offset[p] = 0;
    recv_offset[p] = 0;
  }
  sendl_self = 0;
  tot_recvl = 0;


  /*===== Clear target array =====*/

  for (i=0; i<t_L[0]; ++i)
    T0[i] = 0;

  for (i=0; i<s_L[0]; ++i) {
    S0_lidx[i] = (Data_Type) i;
    
    P0_lidx[i] = map_to_local(TARGET, P0[i], 0);
    P0_pnum[i] = map_to_proc(TARGET, P0[i], 0);
  }

}


