/******************************************************************************
 *                                                                            *
 *  Global variables used in main_*()                                         *
 *                                                                            *
 ******************************************************************************/

#define Default_K            4
#define Default_bucket_size  4
#define Default_dense_factor 1.0

/*#define Default_comm_osc_alg  10        * My Async */ 
/*#define Default_comm_tsc_alg  2	  * Scarab Async */  

#define Default_comm_osc_alg  0  /* linear_permutation_cmmd */
#define Default_comm_tsc_alg  0	 /* linear_permutation_cmmd */
#define Default_comm_msc_alg  0         /* AM-PUT */
#define PrintMax   128

#define DIV_pr_control        10

/*-----------------------------  Argunent Control ---------------------------*/

int comm_osc_alg, comm_tsc_alg, comm_msc_alg;
int pr_control;			/* pr_control mod DIV_pr_control */
int sample_control;		/* pr_control div DIV_pr_control */

double all_local_dense_factor;

/*------------------------------- Sample Data -------------------------------*/

double Hrange;
double Hrange_Seed;		/* Hrange + Seed */

int Hot[Hot_Proc_Max];
int seed;

/***
int nlc[PrintMax], wlc[PrintMax], plc[PrintMax];
int nlc2[PrintMax], wlc2[PrintMax], plc2[PrintMax];
**/

double hot_degree;
double hot_fnum;
int hot_num;

/*------------------------------- Timing Data ------------------------------*/

double nlc_total,       /* total time = nlc_lcomp_total + nlc_comm */
       nlc_tot,         /* use timer */

       nlc_lcomp_total, /* total local computation */
                        /* = nlc_setup + nlc_scan1 + nlc_scan2 + nlc_decomp */
       nlc_lcomp_tot,   /* = nlc_tot - ncl_comm */
       nlc_comm,        /* total communication */

       nlc_scan1,       /* first scan */
       nlc_scan2,       /* second scan (message composition) */
       nlc_setup,       /* initialization */
       nlc_decomp,      /* message decomposition */
       nlc_max, nlc_min;

double wlc_total,
       wlc_tot,

       wlc_lcomp_total,
       wlc_lcomp_tot,
       wlc_comm,       

       wlc_scan1,      
       wlc_scan2,      
       wlc_setup,       
       wlc_decomp,     
       wlc_max, wlc_min;

double wlc2_total,
       wlc2_tot,

       wlc2_lcomp_total,
       wlc2_lcomp_tot,
       wlc2_comm,       

       wlc2_scan1,      
       wlc2_scan2,      
       wlc2_setup,       
       wlc2_decomp,     
       wlc2_max, wlc2_min;

double plc_total,       
       plc_tot, 
       plc_lcomp_total,  
       plc_lcomp_tot, 
       plc_comm,       
       plc_scan1,      
       plc_scan2,      
       plc_setup,       
       plc_decomp,     
       plc_max, plc_min;     
       
double plc2_total,       
       plc2_tot, 
       plc2_lcomp_total,  
       plc2_lcomp_tot, 
       plc2_comm,       
       plc2_scan1,      
       plc2_scan2,      
       plc2_setup,       
       plc2_decomp,     
       plc2_max, plc2_min;     
       

double nlc_raw_total,           /* nlc_raw_lcomp_total + nlc_raw_comm_total */
       nlc_raw_tot,             /* use timer */

       nlc_raw_lcomp_total,     /* nlc_common_setup +
                                   nlc_raw_set + nlc_raw_scan1 +
                                   nlc_raw_lcomp_stage1 + 
                                   nlc_raw_lcomp_stage2 */
       nlc_raw_lcomp_tot,       /* = nlc_raw_tot - ncl_raw_comm_total */

       nlc_raw_comm_total,      /* nlc_raw_comm_stage1 + nlc_raw_comm_stage2 +
                                   nlc_raw_comm_global_stage1 +
                                   nlc_raw_comm_global_stage2 */

       nlc_raw_stage1_total,    /* nlc_raw_scan1 + nlc_raw_lcomp_stage1 +
                                   nlc_raw_comm_stage1 +
                                   nlc_raw_comm_global_stage1 */

       nlc_raw_stage2_total,    /* nlc_raw_lcomp_stage2 +
                                   nlc_raw_comm_stage2 +
                                   nlc_raw_comm_global_stage2 */

       nlc_raw_stage1_tot,      /* use timer */
       nlc_raw_stage2_tot,      /* use timer */

       nlc_raw_set,       
       nlc_raw_scan1,      
       nlc_raw_lcomp_stage1,      
       nlc_raw_lcomp_stage2,      
       nlc_raw_comm_stage1,      
       nlc_raw_comm_stage2, 
       nlc_raw_comm_global_stage1,
       nlc_raw_comm_global_stage2,
       nlc_common_setup,     
       nlc_raw_max, nlc_raw_min;

            
double wlc_raw_total,           
       wlc_raw_tot,             
				  
       wlc_raw_lcomp_total,     
       wlc_raw_lcomp_tot,
       wlc_raw_comm_total,      
				  
       wlc_raw_stage1_total,    
       wlc_raw_stage2_total,    
       wlc_raw_stage1_tot,    
       wlc_raw_stage2_tot,    
                                
       wlc_raw_set,       
       wlc_raw_scan1,      
       wlc_raw_lcomp_stage1,      
       wlc_raw_lcomp_stage2,      
       wlc_raw_comm_stage1,      
       wlc_raw_comm_stage2, 
       wlc_raw_comm_global_stage1,
       wlc_raw_comm_global_stage2,
       wlc_common_setup,     
       wlc_raw_max, wlc_raw_min;


double wlc2_raw_total,           
       wlc2_raw_tot,             
				  
       wlc2_raw_lcomp_total,     
       wlc2_raw_lcomp_tot,
       wlc2_raw_comm_total,      
				  
       wlc2_raw_stage1_total,    
       wlc2_raw_stage2_total,    
       wlc2_raw_stage1_tot,    
       wlc2_raw_stage2_tot,    
                                
       wlc2_raw_set,       
       wlc2_raw_scan1,      
       wlc2_raw_lcomp_stage1,      
       wlc2_raw_lcomp_stage2,      
       wlc2_raw_comm_stage1,      
       wlc2_raw_comm_stage2, 
       wlc2_raw_comm_global_stage1,
       wlc2_raw_comm_global_stage2,
       wlc2_common_setup,     
       wlc2_raw_max, wlc2_raw_min;


double plc_raw_total,           
       plc_raw_tot,             
				  
       plc_raw_lcomp_total,     
       plc_raw_lcomp_tot,
       plc_raw_comm_total,      

       plc_raw_stage1_total,    
       plc_raw_stage2_total,    
       plc_raw_stage1_tot,    
       plc_raw_stage2_tot,    
                                
       plc_raw_set,       
       plc_raw_scan1,      
       plc_raw_lcomp_stage1,      
       plc_raw_lcomp_stage2,      
       plc_raw_comm_stage1,      
       plc_raw_comm_stage2, 
       plc_raw_comm_global_stage1,
       plc_raw_comm_global_stage2,
       plc_common_setup,     
       plc_raw_max, plc_raw_min;


double plc2_raw_total,           
       plc2_raw_tot,             
				  
       plc2_raw_lcomp_total,     
       plc2_raw_lcomp_tot,
       plc2_raw_comm_total,      
				  
       plc2_raw_stage1_total,    
       plc2_raw_stage2_total,    
       plc2_raw_stage1_tot,    
       plc2_raw_stage2_tot,    
                                
       plc2_raw_set,       
       plc2_raw_scan1,      
       plc2_raw_lcomp_stage1,      
       plc2_raw_lcomp_stage2,      
       plc2_raw_comm_stage1,      
       plc2_raw_comm_stage2, 
       plc2_raw_comm_global_stage1,
       plc2_raw_comm_global_stage2,
       plc2_common_setup,     
       plc2_raw_max, plc2_raw_min;


double split_total,       /* total time = split_lcomp_total + split_comm */
       split_tot,         /* use timer */
       split_comm,        /* total communication */

       split_lcomp_total, /* total local computation */
                          /* = split_lcomb + split_lgp + split_lcopy */
       split_lcomp_tot,   /* = split_tot - split_comm */
       split_lcomb,	    /* initial local combining */
       split_lgp,	    /* local computation for Lg P stage */
       split_lcopy,	    /* final local copy or unpack */

       split_common_setup,
       split_max, split_min;


double c_split_total,       
       c_split_tot,         
       c_split_comm,        

       c_split_lcomp_total, 
                          
       c_split_lcomp_tot, 
       c_split_lcomb,	    
       c_split_lgp,	    
       c_split_lcopy,	    

       c_split_common_setup,
       c_split_max, c_split_min;

double r_split_total,       
       r_split_tot,         
       r_split_comm,        

       r_split_lcomp_total, 
                          
       r_split_lcomp_tot, 
       r_split_lcomb,	    
       r_split_lgp,	    
       r_split_lcopy,	    

       r_split_common_setup,
       r_split_max, r_split_min;


/*------------------------------- Message Size ------------------------------*/

int nlc_send,  nlc_recv;
int wlc_send,  wlc_recv;
int wlc2_send, wlc2_recv;
int plc_send,  plc_recv;
int plc2_send, plc2_recv;

int nlc_raw_send, nlc_raw_recv, nlc_raw_sendSP, nlc_raw_recvSP;
int wlc_raw_send, wlc_raw_recv, wlc_raw_sendSP, wlc_raw_recvSP;
int plc_raw_send, plc_raw_recv, plc_raw_sendSP, plc_raw_recvSP;
int plc2_raw_send, plc2_raw_recv, plc2_raw_sendSP, plc2_raw_recvSP;

extern  int total_send, total_recv;     /*----- from "raw_global.h" -----*/
extern  int total_sendSP, total_recvSP; /*----- from "raw_global.h" -----*/

/*------------------------------- IParray Size ------------------------------*/
int nlc_raw_IPsize;
int wlc_raw_IPsize;
int wlc2_raw_IPsize;
int plc_raw_IPsize;
int plc2_raw_IPsize;

extern  IPsize, Ipsize_all;     /*----- from "raw_global.h" -----*/


