/********************************************************************************

 Programmed by SEUNG-JO BAE (3/8/95)

  - Goal: Random Access Write

  - Algorithm: Ravi's

  - Input: Source array & its associated pointer array

  - Output: Target array

  - Version: 1.2
            
     - Assumption: 1) s_tot_nproc = t_nproc
                   2) rank = 1
                   3) Block distribution

  - Note: 1) Set all timer (5/27/96)

********************************************************************************/

#include "global.h"
#include "main-global.h"


/******************************************************************************
 *                                                                            *
 *  Function : void nplc_short_output()                                       *
 *                                                                            *
 ******************************************************************************/


void nplc_short_output()
{
  int i;
  double barrier;

if (only_master) {

  /*---------------------- Print timing results ------------------------------*/

  printf("\n  ------------------------------------------------------------------------------------------------");
  printf("\n    Rank ||   SL |   SP |   SW ||   TL |   TP |   TW || degre| h_num|    K | LD_f ||  OSC |  TSC");
  printf("\n  ------------------------------------------------------------------------------------------------");
  printf("\n    %4d || %4d | %4d | %4d || %4d | %4d | %4d || %4.2f | %4d | %4d | %4.1f || %4d | %4d",                
         t_rank, s_L[0], s_nproc[0], s_width[0], t_L[0], t_nproc[0], t_width[0], 
         hot_degree, hot_num, K_value, local_dense_factor, comm_osc_alg, comm_tsc_alg);
  printf("\n  ------------------------------------------------------------------------------------------------");


  printf("\n\n%.2f\n",hot_degree);
  printf("---------------------------------\n");  

  printf("  K |   total    total    total\n"); 

  printf("---------------------------------\n");  



  printf(" %2d |%8.2f %8.2f %8.2f\n",
         K_value, nlc_total, nlc_raw_total, plc_raw_total);
}

}

/******************************************************************************
 *                                                                            *
 *  Function : void nlc_long_output()                                         *
 *                                                                            *
 ******************************************************************************/


void nlc_long_output()
{
  int i,d;
  double barrier;

if (only_master) {

  printf("\n\n**************************************************************");
  printf("\n                  INPUT DATA (Rank = %d)", t_rank);
  printf("\n**************************************************************");
  printf("\n Total number of processors: Source = %d", s_tot_nproc);
  printf("\n                             Target = %d\n", t_tot_nproc);
  printf("\n Reset partition size = %d", tot_nproc);
  printf("\n--------------------------------------------------------------");

  for (d=0; d<t_rank; ++d) {
    printf("\n <<< Dimension = %d >>>\n", d);
    printf("\n Source Domain Size     = %d", s_N[d]);
    printf("\n        Processors      = %d", s_nproc[d]);
    printf("\n        Partition Width = %d", s_width[d]);
    printf("\n        Local domain    = %d", s_L[d]);
    printf("\n        Tile Width      = %d", s_twidth[d]);
    printf("\n        Number of Tile  = %d\n", s_ntile[d]);
    for (i=0; i<s_nproc[d]; ++i)
            printf("        [PN:%2d] Local size = %d\n", i, s_L_table[d][i]);
    printf("        L_Max = %d\n", s_L_max[d]);
    printf("\n Target Domain Size     = %d", t_N[d]);
    printf("\n        Processors      = %d", t_nproc[d]);
    printf("\n        Partition Width = %d", t_width[d]);
    printf("\n        Local domain    = %d", t_L[d]);
    printf("\n        Tile Width      = %d", t_twidth[d]);
    printf("\n        Number of Tile  = %d\n", t_ntile[d]);
    for (i=0; i<s_nproc[d]; ++i)
            printf("        [PN:%2d] Local size = %d\n", i, t_L_table[d][i]);
    printf("        L_Max = %d\n", t_L_max[d]);
    printf("\n--------------------------------------------------------------");
  }

    printf("\n*** s_L_Max = %d\n", s_L_all_max);
    printf("\n*** t_L_Max = %d\n", t_L_all_max);

  printf("\n");

  switch (comm_osc_alg) {
  case 1: printf("\n =====> OSC Communication: SCARAB LP_XOR");
             break;  
  case 2: printf("\n =====> OSC Communication: SCARAB Unscheduling using Async");
             break; 
  case 3: printf("\n =====> OSC Communication: SCARAB Randomized Distributed");
             break;
  case 8: printf("\n =====> OSC Communication: My linear_permutation_cmmd");
             break;
  case 9: printf("\n =====> OSC Communication: My linear_permutation_am_put");
             break;
  case 10: printf("\n =====> OSC Communication: My unschedule_cmmd_async");
  }

  switch (comm_tsc_alg) {
  case 1: printf("\n =====> TSC Communication: SCARAB LP_XOR");
             break;  
  case 2: printf("\n =====> TSC Communication: SCARAB Unscheduling using Async");
             break; 
  case 3: printf("\n =====> TSC Communication: SCARAB Randomized Distributed");
             break;
  case 8: printf("\n =====> TSC Communication: My linear_permutation_cmmd");
             break;
  case 9: printf("\n =====> TSC Communication: My linear_permutation_am_put");
             break;
  case 10: printf("\n =====> TSC Communication: My unschedule_cmmd_async");
  }

  printf("\n");


  /*---------------------- Print timing results ------------------------------*/

  printf("\n  ------------------------------------------------------------------------------------------------");
  printf("\n    Rank ||   SL |   SP |   SW ||   TL |   TP |   TW || degre| h_num|    K | LD_f ||  OSC |  TSC");
  printf("\n  ------------------------------------------------------------------------------------------------");
  printf("\n    %4d || %4d | %4d | %4d || %4d | %4d | %4d || %4.2f | %4d | %4d | %4.1f || %4d | %4d",                
         t_rank, s_L[0], s_nproc[0], s_width[0], t_L[0], t_nproc[0], t_width[0], 
         hot_degree, hot_num, K_value, local_dense_factor, comm_osc_alg, comm_tsc_alg);
  printf("\n  ------------------------------------------------------------------------------------------------");


  printf("\n\n%.2f\n",hot_degree);
  printf("---------------------------------\n");  

  printf("  K |   total    total    total\n"); 

  printf("---------------------------------\n");  

  printf(" %2d |%8.2f %8.2f %8.2f\n",
         K_value, nlc_total, nlc_raw_total, plc_raw_total);
}

}

