/*----------------------------------------------------------------------------*
 *                                                                            *
 *   HPF Array Combining Scatter Function                                     *
 *                                                                            *
 *     - Author: Seungjo Bae                                                  *
 *                                                                            *
 *----------------------------------------------------------------------------*/

#include <values.h>	   /* for machine-dependent maximum and minimum value */

/******************************************************************************
 *                                                                          
 *  Data and buffer type
 *                                                                          
 ******************************************************************************/

typedef enum {TYPE_int, TYPE_double, TYPE_float, TYPE_logic, TYPE_complex} 
   Data_Types;

typedef int    		    INT_Data_Type;    	    
typedef float  		    FLOAT_Data_Type;  	    
typedef double 		    DOUBLE_Data_Type; 	    
typedef enum {False, True}  LOGIC_Data_Type;  	    
typedef struct {
  float Real;			/* real part */
  float Imag;			/* imaginary part */
} COMPLEX_Data_Type;  	    

typedef struct {
  INT_Data_Type data;
  int ptr;
} INT_Buffer_Type;

typedef struct {
  FLOAT_Data_Type data;
  int ptr;
} FLOAT_Buffer_Type;

typedef struct {
  DOUBLE_Data_Type data;
  int ptr;
} DOUBLE_Buffer_Type;

typedef struct {
  LOGIC_Data_Type data;
  int ptr;
} LOGIC_Buffer_Type;

typedef struct {
  COMPLEX_Data_Type data;
  int ptr;
} COMPLEX_Buffer_Type;

typedef enum 
   {ALL, ANY, COPY, COUNT, IALL, IANY, IPARITY, 
    MAXVAL, MINVAL, PARITY, PRODUCT, SUM}
   Operator_Types;

/******************************************************************************
 *                                                                            *
 *  Identity values
 *                                                                            *
 ******************************************************************************/

  int    	  INT_identity;    	    
  float  	  FLOAT_identity;  	    
  double 	  DOUBLE_identity; 	    
  LOGIC_Data_Type LOGIC_identity;  	    
  COMPLEX_Data_Type 	  COMPLEX_identity;  	    

/******************************************************************************
 *                                                                            *
 *  Maximum values
 *                                                                            *
 ******************************************************************************/

/***
#define INT_Max 32767
#define INT_Min -32768
#define INT_One -32768

#define LONG_Max 2147483647
#define LONG_Min -2147483648
#define LONG_One -2147483648 

#define FLOAT_Max 32767
#define FLOAT_Min -32768
#define FLOAT_One -32768

#define DOUBLE_Max 32767
#define DOUBLE_Min -32768
#define DOUBLE_One -32768
***/

#define INT_Max     MAXINT
#define INT_Min     (- MAXINT) - 1
#define INT_One     -1

#define FLOAT_Max   MAXFLOAT
#define FLOAT_Min   - MAXFLOAT

#define DOUBLE_Max  MAXDOUBLE
#define DOUBLE_Min  - MAXDOUBLE

/***
/home/R4D/dbc/Adlib/src/include/platform.h
***/
